#include "hmg.ch"

Procedure Report_order

   SET BROWSESYNC ON
   SET NAVIGATION EXTENDED

   SET DATE GERMAN // for test
   SET CENTURY ON  // for test

   *SET procedure to use_dbf // for test

   DEFINE WINDOW Rep_1 ;
      AT 0, 0 ;
      WIDTH 400 ;
      HEIGHT 400 ;
      TITLE "Report ORDER" ;
      MODAL 

      ON KEY ESCAPE ACTION Rep_1.Release 

      @ 50, 100  LABEL Label_1 VALUE "ORDERNO"
      @ 50, 150  TEXTBOX  pORDERNO     WIDTH 110 NUMERIC INPUTMASK "9999999999"

   @ 150, 150 BUTTON PRINT_3990 ;
      CAPTION " Create report " ;
      ACTION rep_create_3990() ;
      WIDTH 100

   END WINDOW

   Rep_1.CENTER
   ACTIVATE WINDOW Rep_1

RETURN
*----------------------------------------*
PROCEDURE rep_create_3990

PRIVATE mPrinter, nCurLine:=300, nCurPage:=0, nPageSize:=280, nVMargin:=10, nHMargin:=10 
PRIVATE cFontName:="Verdana", nFontSize:=8, nFontHeight:=4, nCharWidth:=2 

_order := Rep_1.pORDERNO.Value

USE_ORDDET()   // function from USE_DBF.prg 

sumr_06 := 0 

   mPrinter := GetPrinter()
   IF Empty ( mPrinter )
      MsgExclamation( "Printer not selected" )
      RETURN NIL
   ENDIF

   SELECT PRINTER mPrinter ;
      ORIENTATION PRINTER_ORIENT_PORTRAIT ;
      PAPERSIZE PRINTER_PAPER_A4 ;
      PREVIEW 

   START PRINTDOC NAME "report" 

DBGOTOP()
DO WHILE .NOT. EOF()

if orderno != _order
   dbskip()
   loop
endif

sumr_06 := sumr_06 + SAL       

   IF nCurLine > nPageSize
      hdr_3990()
   ENDIF

   nCurLine += nFontHeight
   nCurCol = nHMargin + 1 * nCharWidth + 10 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( ORDERNO, "9999999999") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 12 * nCharWidth + 10 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( ITEMNO, "9999999999") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 23 * nCharWidth + 10 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( PARTNO, "9999999999") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 34 * nCharWidth + 11 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( QTY, "99999999999") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 46 * nCharWidth + 8 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( PRICE, "99999.99") FONT cFontName SIZE nFontSize RIGHT
   nCurCol = nHMargin + 55 * nCharWidth + 10 * nCharWidth 
   @ nCurLine, nCurCol PRINT  TRANSFORM ( SAL, "9999999.99") FONT cFontName SIZE nFontSize RIGHT

   DBSKIP()
ENDDO
nCurLine += nFontHeight

nCurLine += nFontHeight
nCurCol = nHMargin + 55 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5

nCurLine += nFontHeight
nCurCol = nHMargin + 55 * nCharWidth + 10 * nCharWidth 
@ nCurLine, nCurCol PRINT  TRANSFORM ( sumr_06, "9999999.99") FONT cFontName SIZE nFontSize BOLD RIGHT

   END PRINTPAGE
END PRINTDOC

DBCLOSEALL()

Rep_1.RELEASE

RETURN 0
*----------------------------------------*
FUNCTION hdr_3990

nCurPage++
nCurLine := nVMargin

IF nCurPage > 1
   END PRINTPAGE
ENDIF

   START PRINTPAGE

@ nCurLine, 10 PRINT "Date : " + DTOC(date()) FONT cFontName SIZE nFontSize // BOLD
@ nCurLine, 180 PRINT "Page : " + STR(nCurPage, 3) FONT cFontName SIZE nFontSize // BOLD
@ nCurLine, 100 PRINT "TITLE of Report" FONT cFontName SIZE nFontSize+2 CENTER BOLD
nCurLine += nFontHeight

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth
@ nCurLine, nCurCol PRINT "ORDERNO" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 12 * nCharWidth
@ nCurLine, nCurCol PRINT "ITEMNO" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 23 * nCharWidth
@ nCurLine, nCurCol PRINT "PARTNO" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 34 * nCharWidth
@ nCurLine, nCurCol PRINT "QTY" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 46 * nCharWidth
@ nCurLine, nCurCol PRINT "PRICE" FONT cFontName SIZE nFontSize BOLD
nCurCol = nHMargin + 55 * nCharWidth
@ nCurLine, nCurCol PRINT "SAL" FONT cFontName SIZE nFontSize BOLD

nCurLine += nFontHeight
nCurCol = nHMargin + 1 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 12 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 23 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 34 * nCharWidth
nCurCol2 = nCurCol + 11 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 46 * nCharWidth
nCurCol2 = nCurCol + 8 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5
nCurCol = nHMargin + 55 * nCharWidth
nCurCol2 = nCurCol + 10 * nCharWidth
@ nCurLine+2, nCurCol PRINT LINE TO nCurLine+2, nCurCol2 PENWIDTH .5


RETURN 0
